import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;


/**
 * Write a description of class Battleship here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Battleship extends World
{
    public static boolean computerTurn = false; //Tells computer when to make a move 
    public boolean hit = false; // Tells whether or not a hit was guessed on the previous turn
    private static int hitX; //  X Location of previous guess
    private static int hitY; // Y Location of previous guess
    private int x; // X Location of new guess
    private int y; // Y Location of new guess
    private int streak; // Number of hits in a row
    /**
     * Constructor for objects of class Battleship.
     * 
     */
    public Battleship()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(32, 22, 20); 
        setup();
    }
    
    /**
     * Tells computer when to guess
     */
    public void act()
    {
        if(Crosshair.playerTurn == false)
            {
                computerTurn = true;
            }
        if(computerTurn)
        {
            guess();
            endGame();
            
        }
        
        
        Crosshair.playerTurn = true;
        computerTurn = false;
    }
    
    /**
     * Places the ships and blocks on the board. Computer ships are somewhat random.
     */public void setup()
    {
        for(int x=0;x<=9;x++)
        {
            for(int y=0;y<=9;y++)
            {
                addObject(new Block(), x +4, y+6);
                addObject(new Block(), x +17, y+6);
            }
        }
        addObject(new Ship3(),5,17);
        addObject(new Ship3(),10,17);
        addObject(new Ship5(),6,19);
        addObject(new Ship5(),6,21);
        addObject(new Start(),15,20);
        
        int x =  19;
        int y = Greenfoot.getRandomNumber(5) + 6;
        addObject(new CompShip5(),x,y);
        
        int a = 24;
        int b = Greenfoot.getRandomNumber(5) + 11;
        addObject(new CompShip5(),a,b);
        
        int c = 23 + Greenfoot.getRandomNumber(3);
        int d = Greenfoot.getRandomNumber(5) + 6;
        addObject(new CompShip3(),c,d);
        
        int e = 19 + Greenfoot.getRandomNumber(3);
        int f = Greenfoot.getRandomNumber(5) + 11;
        addObject(new CompShip3(),e,f);
        
        
        
    }
    
    /**
     * Defines how the computer should make its guesses
     * Random at first and then more specific guessing
     */
    public void guess()
    {
        
        if(hit == false)
        {
            x = Greenfoot.getRandomNumber(10) + 4;
            y = Greenfoot.getRandomNumber(10) + 6;
        }
        
        if(hit == true)
        {
            if(streak == 1)
            {
                int random = Greenfoot.getRandomNumber(4);
                switch(random)
                {
                        case 0: x = hitX + Greenfoot.getRandomNumber(2);
                        y = hitY; 
                        break; 
                        case 1: x = hitX;
                        y = hitY - Greenfoot.getRandomNumber(2); 
                        break;
                        case 2: x = hitX - Greenfoot.getRandomNumber(2);
                        y = hitY ; 
                        break;
                        case 3: x = hitX;
                        y = hitY + Greenfoot.getRandomNumber(2); 
                        break;
                    }
            }
            if(streak > 1)
            {
                List range1 = getObjectsAt(hitX + 1, hitY, Hit.class);
                List range2 = getObjectsAt(hitX - 1, hitY, Hit.class);
                List range3 = getObjectsAt(hitX, hitY + 1, Hit.class);
                List range4 = getObjectsAt(hitX, hitY - 1, Hit.class);
                int random = Greenfoot.getRandomNumber(2);
                
                if(range1.size() > 0 && range2.size() == 0 && range3.size() == 0 && range4.size() == 0)
                {
                     
                     switch(random)
                     {
                        case 0: x = hitX + 2;
                        y = hitY; 
                        break; 
                        case 1: x = hitX - 1;
                        y = hitY; 
                        break;
                    }
                }
                
                if(range1.size() == 0 && range2.size() > 0 && range3.size() == 0 && range4.size() == 0)
                {
                    switch(random)
                     {
                        case 0: x = hitX - 2;
                        y = hitY; 
                        break; 
                        case 1: x = hitX + 1;
                        y = hitY; 
                        break;
                    }
                }
                if(range1.size() == 0 && range2.size() == 0 && range3.size() > 0 && range4.size() == 0)
                {
                    switch(random)
                     {
                        case 0: x = hitX;
                        y = hitY + 2; 
                        break; 
                        case 1: x = hitX;
                        y = hitY - 1; 
                        break;
                    }
                }
                if(range1.size() == 0 && range2.size() == 0 && range3.size() == 0 && range4.size() > 0)
                {
                    switch(random)
                     {
                        case 0: x = hitX;
                        y = hitY - 2; 
                        break; 
                        case 1: x = hitX;
                        y = hitY + 1; 
                        break;
                    }
                }
            }
            
        }
        else
        {
            hit = false;
            streak = 0;
        }
        
        
        
        
        
        
        List checkShip = getObjectsAt(x,y,Ship.class);
        List check = getObjectsAt(x,y,Guess.class);
   
        if(checkShip.size() > 0 && check.size() > 0)
        {
           guess(); 
        }
        if(checkShip.size() > 0 && check.size() == 0 && xAndY())
        {
            addObject(new Hit(),x,y);
            hit = true;
            streak = streak + 1;
            hitX = x;
            hitY = y;
        }
        if(checkShip.size() == 0 && check.size() == 0 && xAndY())
        {
            addObject(new Miss(),x,y);
            hit = false;
            streak = 0;
        }
        if(checkShip.size() == 0 && check.size() > 0 )
        {
            guess();
        }
        if(xAndY() == false)
        {
            guess();
        }
        }
    
    /**
     * Make sure the guess is inside the grid
     */
    public boolean xAndY()
    {
        if(x > 3 && x < 14 && y > 5 && y < 16)
            {
                return true;
        
            }
            else{return false;}
            
    }
    
    /**
     * End the game
     */
    public void endGame()
    {
        if(Ship5.sunk && Ship3.sunk || CompShip5.sunk && CompShip3.sunk)
        {
            Greenfoot.stop();
        }
    }
}
